import java.io.File;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class CheatEngineSearchData {
	
	private final Map<String, String> _ctData = new LinkedHashMap<>();
	
	public CheatEngineSearchData(String fileName){
	
		try {
			File cheatTable = new File(fileName);
			SAXParserFactory factory = SAXParserFactory.newInstance();
			SAXParser saxParser = factory.newSAXParser();
			DocumentHandler parseDocument = new DocumentHandler();
			saxParser.parse(cheatTable, parseDocument);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public Map<String, String>getCtData() {
		return _ctData;
	}
	
	class DocumentHandler extends DefaultHandler {
		boolean bAddr = false;
		String sAddr = "";
		String sValue = "";
		
		@Override
		public void startElement(String uri, String localName, String qName, Attributes attributes)
		throws SAXException {
			
			if (qName.equalsIgnoreCase("Address")){
				bAddr = true;
			} else if (qName.equalsIgnoreCase("LastState")) {
				sValue = attributes.getValue("Value");
			}
		}
		
		@Override
		public void characters(char ch[], int start, int length) throws SAXException {
			if (bAddr){
				sAddr = new String(ch, start, length);
				bAddr = false;
			}
		}
		
		@Override
		public void endElement(String uri, String localName, String qName)
		throws SAXException {
			if (qName.equalsIgnoreCase("CheatEntry"))
				_ctData.put(sAddr, sValue);
		}
		
	}
}
