import java.io.File;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class Converter {
	
	/**Defines the start of your dump*/
	static String _stAddr = "10000000";
	static String _addrType = "32";
	
	public static void main (String args[]){
		if (args.length < 2){
			System.out.println("Please specify an input file as first argument and a name for the output file as second argument");
			System.out.println("Optional: 3rd argument = start address of dump in hex (default 10000000); 4th argument = value size (default 32)"); 
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			System.exit(1);
		}
		if (args.length >= 3 ) {
			_stAddr = args[2];
		}
		if (args.length >= 4 ) {
			if (args[3].equals("8") || args[3].equals("16") || args[3].equals("32"))
				_addrType = args[3];
			else {
				System.out.println("Valid values are 8, 16 or 32");
			}
		}
		
		File out = new File(args[1]);
		
		Map<String, String> ctData = new HashMap<>();
		
		CheatEngineSearchData cesd = new CheatEngineSearchData(args[0]);
		ctData = cesd.getCtData();
		String ea = "50000000";
		//get last entry for end_address
		for (Map.Entry<String, String> ctEntry : ctData.entrySet()) {
			ea = ctEntry.getKey();
		}
		ea = Integer.toHexString(Integer.valueOf(ea,16)+Integer.valueOf(_stAddr,16)+4);
		
		//Debug
		/*for (Map.Entry<String, String> ctEntry : ctData.entrySet()){
			System.out.println("Key = " + ctEntry.getKey() + ", Value = " + ctEntry.getValue());
		}*/
		
		try {
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.newDocument();
			
			Element rootElement = doc.createElement("memory_search");
			doc.appendChild(rootElement);
			Element settings = doc.createElement("settings");
			rootElement.appendChild(settings);
			Element startAddress = doc.createElement("start_address");
			startAddress.appendChild(doc.createTextNode(_stAddr));
			settings.appendChild(startAddress);
			Element endAddress = doc.createElement("end_address");
			endAddress.appendChild(doc.createTextNode(ea));
			settings.appendChild(endAddress);
			Element valueSize = doc.createElement("value_size");
			valueSize.appendChild(doc.createTextNode(_addrType + "-Bit"));
			settings.appendChild(valueSize);
			
			Element results = doc.createElement("results");
			rootElement.appendChild(results);
			for (Map.Entry<String, String> ctEntry : ctData.entrySet()){
				Element result = doc.createElement("result");
				Attr offsetAttr = doc.createAttribute("offset");
				offsetAttr.setValue(ctEntry.getKey());
				//offsetAttr.setValue(Integer.toHexString(Integer.valueOf(ctEntry.getKey(),16)+Integer.valueOf(_stAddr,16)));
				result.setAttributeNode(offsetAttr);
				Element previousValue = doc.createElement("previous_value");
				previousValue.appendChild(doc.createTextNode(ctEntry.getValue()));
				result.appendChild(previousValue);
				Element currentValue = doc.createElement("current_value");
				currentValue.appendChild(doc.createTextNode(ctEntry.getValue()));
				result.appendChild(currentValue);
				results.appendChild(result);
			}
			
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			DOMSource source = new DOMSource(doc);
			StreamResult result = new StreamResult(out);
			transformer.transform(source, result);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		ZipWriter zw = new ZipWriter();
		zw.createZipWithOneFile(args[1]);
		
		out.delete();
	}
}
